#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_BulletHeadCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_BulletHeadCFG> Fish_BulletHeadCFG::msSingleton(nullptr);

int Fish_BulletHeadCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_BulletHeadCFGData* Fish_BulletHeadCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_BulletHeadCFGData>& Fish_BulletHeadCFG::GetMapData()
{
	return mMapData;
}

void Fish_BulletHeadCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_BulletHeadCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_BulletHeadCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mAttackMode = element->IntAttribute("AttackMode");
		data.mGemPrice = element->IntAttribute("GemPrice");
		data.mBallPrice = element->IntAttribute("BallPrice");
		data.mGoldKillMin = element->IntAttribute("GoldKillMin");
		data.mGoldKillMax = element->IntAttribute("GoldKillMax");
		data.mThreshold = element->IntAttribute("Threshold");
		{
			const char* RandParam = element->Attribute("RandParam");
			std::vector<std::string> vecRandParam;
			boost::split(vecRandParam, RandParam, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRandParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRandParam[i].c_str(), &temp))
				{
					data.mRandParam.push_back(temp);
				}
			}
		}
		{
			const char* NoContributeRandParam = element->Attribute("NoContributeRandParam");
			std::vector<std::string> vecNoContributeRandParam;
			boost::split(vecNoContributeRandParam, NoContributeRandParam, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNoContributeRandParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNoContributeRandParam[i].c_str(), &temp))
				{
					data.mNoContributeRandParam.push_back(temp);
				}
			}
		}
		{
			const char* EverydayBuff = element->Attribute("EverydayBuff");
			std::vector<std::string> vecEverydayBuff;
			boost::split(vecEverydayBuff, EverydayBuff, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecEverydayBuff.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecEverydayBuff[i].c_str(), &temp))
				{
					data.mEverydayBuff.push_back(temp);
				}
			}
		}
		data.mGoldUseMin = element->IntAttribute("GoldUseMin");
		data.mGoldUseMax = element->IntAttribute("GoldUseMax");
		{
			const char* TelephoneDrop = element->Attribute("TelephoneDrop");
			std::vector<std::string> vecTelephoneDrop;
			boost::split(vecTelephoneDrop, TelephoneDrop, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecTelephoneDrop.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecTelephoneDrop[i].c_str(), &temp))
				{
					data.mTelephoneDrop.push_back(temp);
				}
			}
		}
		data.mNotifyMsgCond = element->IntAttribute("NotifyMsgCond");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_BulletHeadCFG::Load()
{
	Load("../Config/Fish_BulletHeadCFG.xml");
}

Fish_BulletHeadCFG* Fish_BulletHeadCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_BulletHeadCFG());
	}
	return msSingleton.get();
}
